// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js


angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ngCordova'])

.run(function ($ionicPlatform, $state, $rootScope) {
  $ionicPlatform.ready(function() {
    console.log("Inside platform ready");
    
    //We should only call Parse.Initialize once
    Parse.initialize('ZmqvFWg6V7u0ny8bX24u7PAnKvfewOvRDxfNdoxH', 'HlzTePUSlhYKCukte0Jkx0BoITzuxezBs7Zvo521'); 

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
  console.log("CONFIGURING APP");
  
  $ionicConfigProvider.tabs.position('bottom'); // other values: top

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
  .state('tab', {
      url: "/tab?clear",
      abstract: true,
      templateUrl: "templates/tabs.html",
      controller: 'AppController'
  })

  // Each tab has its own nav history stack:
  .state('welcome', {
      url:'/welcome?clear',
      templateUrl: 'templates/welcome.html',
      controller: 'WelcomeController'
  })

 .state('forgot', {
      cache: false,
      url: '/forgot?clear',
      templateUrl: 'templates/forgot.html',
      controller: 'ForgotPasswordController'
    })

  .state('register', {
      cache: false,
      url: '/register?clear',
      templateUrl: 'templates/register.html',
      controller: 'RegisterController'
  })

  .state('tab.instructions', {
      cache: true,
      url: '/instructions',
      views: {
        'tab-instructions': {
          templateUrl: 'templates/tab-instructions.html',
          controller: 'InstructionsCtrl'
        }
      }
  })

  .state('tab.reports', {
      cache: false,
      url: '/reports',
      views: {
        'tab-reports': {
          templateUrl: 'templates/tab-reports.html',
          controller: 'ReportsCtrl'
        }
      }
    })
  
  .state('tab.report-detail', {
      cache: true,
      url: '/report/:reportId',
      views: {
        'tab-reports': {
          templateUrl: 'templates/report-detail.html',
          controller: 'ReportDetailCtrl'
        }
      }
    })

  .state('tab.drivingMode', {
      cache: true,
      url: '/drivingMode',
      views: {
        'tab-drivingMode': {
          templateUrl: 'templates/tab-drivingMode.html',
          controller: 'drivingModeCtrl'
        }
      }
  })

  .state('tab.profile', {
      cache: false,
      url: '/profile',
      views: {
        'tab-profile': {
          templateUrl: 'templates/tab-profile.html',
          controller: 'ProfileCtrl'
        }
      }
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/welcome');

});
