document.addEventListener('deviceready', function () {
    // Android customization
    cordova.plugins.backgroundMode.setDefaults({ text:'Truckblox is working..'});
    // Enable background mode
    cordova.plugins.backgroundMode.enable();

    // Called when background mode has been activated
    cordova.plugins.backgroundMode.onactivate = function () {
        setTimeout(function () {
            // Modify the currently displayed notification
            cordova.plugins.backgroundMode.configure({
                text:'Running in background for more than 5s now.'
            });
        }, 5000);
    }
}, false);

//https://calendee.com/2013/12/29/angularjs-code-organization/
angular.module('starter.controllers')


//REPORTS PAGE
.controller('ReportsCtrl', function($q, $scope, $rootScope, Reports, MediaSrv, ClockSrv, ReportSrv, $cordovaCapture, $cordovaGeolocation, $ionicLoading, $ionicPopup, $ionicPlatform) {

    /************* INITIAL GET LOCATION *************/
    var userReportsArray = [];
    $scope.promises = [];
    var isPlayingRecordings = false;
    var UserReportsArrayPos = 0;
    var hornSwitch = true;
    $scope.isLoading = true;  //set for the display
    $scope.hasListings = false;

    // $rootScope.counter = 0;

    var watchOptions = {
        frequency : 15 * 60 * 1000,
        timeout : 10 * 60 * 1000,
        enableHighAccuracy: false // may cause errors if true
    };

    if (!$scope.watchPositionID) {
        $scope.watchPositionID = $cordovaGeolocation.watchPosition(watchOptions);
        $scope.watchPositionID.then(
            null,
            function(err) {
                console.log("Inside error callback of watchPositionID");
                //document.getElementById("reportsAlert").innerHTML = JSON.stringify(err);
                try {
                    document.getElementById("reportsAlert").innerHTML = "Couldn't find location, please relaunch!";                    
                }
                catch (err) {
                    console.log("Couldn't set reportsAlert.innerHTML, " + err);
                }
            },
            function(position) {
                console.log("Inside success callback of watchPositionID");
                // $rootScope.counter = $rootScope.counter + 1;
                $rootScope.currentLiveLatitude  = position.coords.latitude;
                $rootScope.currentLiveLongitude = position.coords.longitude;

                try {
                    document.getElementById("reportsAlert").innerHTML = "Buckle Up and Drive Safe! ";
                }
                catch (err) {
                    console.log("Couldn't set reportsAlert.innerHTML, " + err);
                }
            }
        );
    }

    //Call this immediately to do the initial page refresh, without waiting 16 seconds.
    getReports();

    $ionicLoading.show({
      duration: 6000,
      noBackdrop: false,
      template: '<h2>One Moment</h2><p>Loading traffic reports near you...</p>'
    });

    $scope.$on('$destroy', function() {
        console.log("Destroying current scope");
        $cordovaGeolocation.clearWatch($scope.watchPositionID);
        $scope.watchPositionID = null;
        ClockSrv.stopClock();
    });

    ClockSrv.stopClock();

    function startClock () {
        ClockSrv.startClock(function(){
            console.log("Start Clock called - updated");
            $scope.doRefresh();
        });
    }

    startClock();

    function handleError(msg) {
        console.log("Error : " + msg);
    }

    function playRecordingSuccess(msg) {
        console.log("Playrecording success : " + msg);
    }

    if (! window.localStorage.getItem("firstTimeRecording")) {
        console.log("firstTimeRecording does not exist, adding and playing first recording");
        var entry = {"attributes": 
                    {
                        "dateTime":"18:37:15",
                        "latitude":"39.975520599999996",
                        "longitude":"-75.1410851",
                        "recording":
                            {"__type":"File",
                            "name":"tfss-d4c26c6f-6060-4b24-a0c2-7bfb744cb605-recording.m4a",
                            "url":"founder-recording.mp3"
                            },
                        "username":"Truckblox Founder",
                        "geoLocation":{"__type":"GeoPoint","latitude":39.975520599999996,"longitude":-75.1410851},
                        "Distance":"0.000",
                        "userPlayed":false,
                        "queueRemove":false,
                        "objectId":"originalxdfaz123",
                        "createdAt":"2015-10-12T22:37:15.934Z",
                        "updatedAt":"2015-10-12T22:37:15.934Z",
                        "Distance" : 0.0,
                        "userPlayed": false,
                        "queueRemove":false,
                        "queueRemove": false
                    }
                }

        userReportsArray.push(entry);
        $scope.reports = userReportsArray;
        
        console.log("Adding Horn and Entry to Promises Queue");
        $scope.promises.push(MediaSrv.loadMedia('sounds/trucksound.mp3', handleError, handleStatus, playHornSuccess));
        $scope.promises.push(MediaSrv.loadMedia('sounds/founder-recording.mp3', handleError, handleStatus, playRecordingSuccess));
        window.localStorage.setItem("firstTimeRecording", true);
    }
    else {
        console.log("firstTimeRecording does not exist, adding and playing first recording");
    }

   function handleStatus(msg) {

        if (msg == 1 ) {
            $scope.isLoading = true; //set this in case a recording is placed AFTER initial loading
        }
        if (msg == 4 && !$scope.promises.length) {
            $scope.isLoading = false; //first time we play a recording, we should have this.
        }
        console.log("Status : " + msg);

        //We need a replacement for ng-show="$first", because it doesn't update on the next element
        if (UserReportsArrayPos == 0){
            userReportsArray[UserReportsArrayPos].attributes["firstElement"] = true;
        }

        if (msg == 4) { // Media.MEDIA_STOPPED = 4;
            console.log("Status = FINISHED, playing next...");
            playNextRecording();

            if (hornSwitch) {
                hornSwitch = false;
                userReportsArray[UserReportsArrayPos].attributes["firstElement"] = true;
            }
            else {
                hornSwitch = true; //reset next increment to be the horn, so irrelevant 
                userReportsArray[UserReportsArrayPos].attributes["firstElement"] = false;
                userReportsArray[UserReportsArrayPos].attributes.userPlayed = true;
                UserReportsArrayPos ++; 
            }
            
        }
    }

    //http://stackoverflow.com/questions/15088327/passing-parameters-when-using-deferred-resolve-and-when
    function playAndRemoveFromList() {
        console.log("************************** START playAndRemoveFromList **************************");

        //remove all banned items
        for (i=0; i < userReportsArray.length; i++) {
            console.log(" objectId[" + i + "] = " + JSON.stringify(userReportsArray[i].id));

            var isNameBannedPosition = JSON.stringify(userReportsArray[i]).indexOf(window.localStorage.getItem("bannedUserNamesCache"));
            if ( isNameBannedPosition >= 0 ) {
                console.log("Banned entry detected in " + JSON.stringify(userReportsArray[i]) + ", removing from list ");
                userReportsArray[i].attributes.userPlayed = true;
            }

            if (userReportsArray[i].attributes.queueRemove) {
                //We want to remove a played recording, on the *next* iteration of 16 seconds
                userReportsArray[i].attributes.userPlayed = true;
            }
        }

        if (!isPlayingRecordings) {
            console.log("!isPlayingRecordings");
            playNextRecording();
        }
    }

    function playNextRecording() {
        console.log("playNextRecording called");
        if ($scope.promises.length > 0) {
            isPlayingRecordings = true;
            var promise = $scope.promises.shift();
            promise.then(function (media) {
                console.log("Inside playNextRecording .then");
                media.play();
            });
        }
        else {
            console.log("promises.length = false");
            isPlayingRecordings = false;
        }
    }

    function getReports() {
        console.log("Inside getReports");

        if ($rootScope.currentLiveLatitude && $rootScope.currentLiveLongitude) {
            console.log("currentLiveLongitude & currentLiveLatitude found, getting reports");
            Reports.getByTime($rootScope.currentLiveLatitude, $rootScope.currentLiveLongitude, function(updatedReports) {
                updatedReports.forEach(function(entry) {
                    var distanceToAdd; //add this distance to the list element
                    //so weird - adding "geolocation" + to the entry.geoLocation print makes it not show up as JSON
                    //console.log("   Object = " + entry.id + " , Lat = " + entry.attributes.latitude + " , Lon = " + entry.attributes.longitude + ".");
                    if (entry.attributes.latitude) {
                        var sample = {
                            latitude: $rootScope.currentLiveLatitude,
                            longitude: $rootScope.currentLiveLongitude
                        };
                
                        distanceToAdd =  ReportSrv.calculateDistance(sample, entry.attributes);
                        
                        entry.attributes["Distance"] = distanceToAdd;
                        entry.attributes["userPlayed"] = false;
                        entry.attributes["queueRemove"] = false;

                    }
                    else {
                        console.log ("Entry does NOT have a valid latitude");
                    }

                    var tempPosition = JSON.stringify(userReportsArray).indexOf(entry.id);
                    if ( tempPosition >= 0 ) {
                        console.log("Entry already exists, Skipping #" + tempPosition );
                    }
                    else {
                        console.log("New entry detected, pushing to array.");
                        userReportsArray.push(entry);
                        console.log("Adding Horn and Entry to Promises Queue");
                        $scope.promises.push(MediaSrv.loadMedia('sounds/trucksound.mp3', handleError, handleStatus, playHornSuccess));
                        $scope.promises.push(MediaSrv.loadMedia(entry.attributes.recording._url, handleError, handleStatus, playRecordingSuccess));
                    }
                })
                $scope.reports = userReportsArray;
                
            });
        }
        else {
            console.log("NO currentLiveLongitude & currentLiveLatitude found, do nothing");
        }
    }

    function playHornSuccess(msg) {
        console.log("Truck recording has played successfully..." + msg);

    }

    $scope.upVote = function(_objectID) {
        console.log("Called upVote button");
        Reports.updateEntryHelpful(_objectID);
    }

    $scope.flagRecording = function(_objectID) {
        console.log("Called flagRecording button");
        
        var confirmPopup = $ionicPopup.confirm({
            title: 'Flag as Offensive',
            template: 'Our team will be notified, and you will not hear any more recordings from this user.'
        });
        confirmPopup.then(function(res) {
            if(res) {
               
                Reports.updateEntryNotHelpful(_objectID);  //we set the bannUserCache in here
                console.log("Inside flagRecording.... after updateEntryNotHelpful");

                $ionicLoading.show({
                  duration: 4000,
                  noBackdrop: false,
                  template: '<h2>One Moment</h2><p>Removing user from Playlist...</p>'
                });

            } else {
                console.log('User canceled request to flag user');
            }
        });
    }

    $scope.doRefresh = function() {
        console.log("************************** START doRefresh() **************************");
        // If android
        if($ionicPlatform.is('android')){
          console.log("Updating settings for Android (Geolocation)");
          posOptions = {timeout: 3600000, maximumAge:10000, enableHighAccuracy: true};
        }
        // If iPhone
        else {
          console.log("Updating settings for iOS (Geolocation)");
          posOptions = {timeout: 4000, maximumAge: 3000 , enableHighAccuracy: false};
        }

        var currentPositionID = $cordovaGeolocation.getCurrentPosition(posOptions);
            currentPositionID.then(
            null,
            function(err) {
                console.log("Error watching geoLocation, err=" + JSON.stringify(err));
            },
            function(position) {
                $rootScope.currentLiveLatitude  = position.coords.latitude;
                $rootScope.currentLiveLongitude = position.coords.longitude;
        });
        getReports()
        playAndRemoveFromList();
    };

    window.localStorage['paused'] = 'false';
    
    $scope.PauseResumeListings = function () {
        console.log("Pause / Resume Listings ");
        if (window.localStorage['paused'] == 'true') {
            console.log("Already paused, starting clock again and setting paused to false");
            document.getElementById("reportsAlert").innerHTML = "Playing reports";
            window.localStorage['paused'] = 'false';

            startClock();
        }
        else if (window.localStorage['paused'] == 'false') {
            ClockSrv.stopClock();
            document.getElementById("reportsAlert").innerHTML = "Pausing reports";
            console.log("Not yet paused, pausing now");
            window.localStorage['paused'] = 'true';
        }
    }
    
    $scope.preCaptureAudio = function() {
        try {
            console.log("Inside preCaptureAudio");

            if (window.localStorage.getItem("cachedHasBeenNotifiedRecordings"))
            {
                console.log("detected cachedHasBeenNotifiedRecordings");
                captureAudio();
            }
            else {
                console.log("ERROR:  User did not yet click cachedHasBeenNotifiedRecordings. How did we get here?");
                var alertPopup = $ionicPopup.alert({
                    title: 'Share your Advisories!',
                    template: '<div class="padding-vertical sides" style="text-align:justify;">Recordings will be uploaded to Truckblox servers and provided to other drivers for advisory purposes.</div>'
                });
                alertPopup.then(function(res) {
                    console.log('User clicked continue for Geolocation popup');
                    window.localStorage.setItem("cachedHasBeenNotifiedRecordings", true);
                    captureAudio();
                });

            }
        }
        catch (err) {
            console.log("Caught an error with preCaptureAudio ... " + err);
        }
    }
    /************* RECORD FUNCTION *************/
    function captureAudio () {

        var localURL;
        var fullPath;
        /************* CAPTURE AUDIO CLIP *************/
        var options = { limit: 1, duration: 10 };
        console.log("Inside record audio, stopping the clock");

        ClockSrv.stopClock(); //let's stop the clock, may take a while for recording to save

        $cordovaCapture.captureAudio(options).then(function(audioData) 
        {
            console.log("Capture audio success, AudioData: " + JSON.stringify(audioData));
            localURL = audioData[0].localURL;
            fullPath = audioData[0].fullPath;
            console.log("localURL = " + localURL);
            console.log("fullPath = " + fullPath);

            $ionicLoading.show({
              duration: 6000,
              noBackdrop: false,
              template: '<h2>Uploading your Recording</h2>'
            });


            function checkIfFileExists(path){
                console.log("Checking path for: " + path);
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                    fileSystem.root.getFile(path, { create: false }, fileExists, fileDoesNotExist);
                }, getFSFail); //of requestFileSystem
            }
            
            function fileExists(fileEntry) {
                console.warn("File " + fileEntry.fullPath + " exists!");
            }
            function fileDoesNotExist(fileEntry) {
                console.log("file does not exist : " + JSON.stringify(fileEntry));
            }
            function getFSFail(evt) {
                console.log(evt.target.error.code);
            }
            
            var usedFilePath = null;

            if($ionicPlatform.is('android')){
                var myTmpString = audioData[0].fullPath;
                console.log("Platform Android, Path (before)= " + myTmpString);
                window.resolveLocalFileSystemURL(myTmpString, function(entry){
                    console.log("inside resolveLocalFileSystemURL, entry = " + JSON.stringify(entry));
                    myTmpString = entry.fullPath;

                    checkIfFileExists(myTmpString);
                    usedFilePath = myTmpString;

                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS, fail);
                    ///never gets this far
                }, function(error){
                      console.log("inside resolvelocalFileSystem error = " + error.code);
                      //*Always fails with error code 5*
                });
            }
            else {
                usedFilePath = audioData[0].name;
                //use temporary for iOS
                window.requestFileSystem(LocalFileSystem.TEMPORARY, 0, gotFS, fail);
            }

            function gotFS(fileSystem) {
                console.log("FileSystem: " + JSON.stringify(fileSystem));
                fileSystem.root.getFile(usedFilePath, {create: false}, gotFileEntry, fail);
            }

            function gotFileEntry(fileEntry) {
                console.log("gotFileEntry:" + JSON.stringify(fileEntry));
                fileEntry.file(gotFile, fail);
            }

            function gotFile(file){
                console.log("gotFile : " + JSON.stringify(file));
                //readBinaryString(file);
                readArrayBuffer(file);
            }

            /* GET TIMESTAMP */
            function checkTime(i) {
                if (i < 10) {
                    i = "0" + i;
                }
                return i;
            }

            function getHHMMSS(){
                var today = new Date();
                var h = today.getHours();
                var m = today.getMinutes();
                var s = today.getSeconds();
                // add a zero in front of numbers<10
                m = checkTime(m);
                s = checkTime(s);
                return h + ":" + m + ":" + s;
            }

            /************* SAVE THE FILE *************/
            function readArrayBuffer(file){
                var reader = new FileReader();

                reader.onloadend = function(evt) {
                    console.log("readArrayBuffer : " + evt.target.result);
                    
                    if (navigator.userAgent.match(/(Android)/)) {
                        console.log("Saving for ANDROID");
                        var ParseFile = new Parse.File("recording.m4a", file);
                    }
                    else {
                        console.log("Saving for iOS");
                        var ParseFile = new Parse.File("recording.wav", file);
                    }
                    ParseFile.save().then(function() 
                    {
                        console.log('Inside ParseFile.save()');

                        if (!($rootScope.currentLiveLongitude || $rootScope.currentLiveLatitude))
                        {
                            $ionicLoading.hide();
                            var alertPopup = $ionicPopup.alert({
                                     title: 'Could not Upload Recording!',
                                     template: ' Geolocation is not enabled!'
                                });
                                alertPopup.then(function(res) {
                                    console.log('User clicked continue for Geolocation popup');
                                });
                            return null;
                        }
                        var myPoint = new Parse.GeoPoint({latitude: $rootScope.currentLiveLatitude, longitude: $rootScope.currentLiveLongitude});
                        var recording = new Parse.Object("Recordings");
                      
                        console.log("Lat = " + $rootScope.currentLiveLatitude);
                        console.log("Lon = " + $rootScope.currentLiveLongitude);
                        console.log("Username = " + $scope.user.attributes.username);

                        recording.set("username", $scope.user.attributes.username);
                        recording.set("latitude", $rootScope.currentLiveLatitude.toString());
                        recording.set("longitude", $rootScope.currentLiveLongitude.toString());
                        recording.set("geoLocation", myPoint);
                        recording.set("dateTime", getHHMMSS());
                        recording.set("recording", ParseFile);

                        console.log("About to actually save");
                        /*Save to server */
                        recording.save({
                            success: function(recording) {
                                $ionicLoading.hide();
                                console.log("Recordings saved successfully, recording: " + JSON.stringify(recording));
                                
                                startClock();
                            },
                            error: function(recording, error){
                                $ionicLoading.hide();
                                var alertPopup = $ionicPopup.alert({
                                     title: 'Couldnt Upload Recording!',
                                     template: 'Are you connected to the Internet?'
                                });
                                alertPopup.then(function(res) {
                                    console.log('User clicked continue for internet popup');
                                    console.log("Recordings save failure, error = " + error + " error msg: " + error.message);
                                    console.log("Recordings save failure, error = " + JSON.stringify(recording));
                                    
                                    startClock();
                                });
                                
                            }
                        });
                    },function(error) {
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                             title: 'Failed to save recording!',
                             template: 'Please check your Internet connection'
                        });
                        alertPopup.then(function(res) {
                            console.log('User clicked continue for internet popup');
                        });
                    });
                }
              reader.readAsArrayBuffer(file);
            }
            //fail function that's passed in to file calls above
            function fail(error) {
                $ionicLoading.hide();
                var alertPopup = $ionicPopup.alert({
                                 title: 'This device will be supported next!',
                                 template: 'We are working on adding your device to our list, stay tuned!'
                            });
                            alertPopup.then(function(res) {
                                console.log('User clicked continue for record message popup');
                            });
                //alert('This device is not supported YET. Check back soon!  Err :' + error.code + 'A');
                console.log("File Fail error A: " + error.code + JSON.stringify(error));
            }
        },
        function(error) {
            var alertPopup = $ionicPopup.alert({
                     title: 'Oops!',
                     template: 'You need to record a message!'
                });
                alertPopup.then(function(res) {
                    console.log('User clicked continue for record message popup');
                });
        });     
    };
})
//sourcee for storing files: https://www.parse.com/docs/js/symbols/Parse.File.html
