angular.module('starter.services', [])

//KEYS have been updated to TruckBlox App
.value('PARSE_CREDENTIALS',{
    APP_ID: 'ZmqvFWg6V7u0ny8bX24u7PAnKvfewOvRDxfNdoxH',
    REST_API_KEY:'IvGQTZODDQyLqbFwKvGClbat8l60WUxwCi9295nu'
})

//Found example of clock at this address
//http://forum.ionicframework.com/t/how-to-call-a-function-at-specific-time-interval-in-application-instead-of-controller-level/8652/3
//There is also an example if we need multiple clocks running synchrounously
.factory('ClockSrv', function($interval){
  var clock = null;
  var service = {
    startClock: function(fn){
      if(clock === null){
        clock = $interval(fn, 6000);
      }
    },
    stopClock: function(){
      if(clock !== null){
        $interval.cancel(clock);
        clock = null;
      }
    }
  };
  return service;
})

.factory('ReportSrv', function(){
    
  function toRad(value) {
      var RADIANT_CONSTANT = 0.0174532925199433;
      return (value * RADIANT_CONSTANT);
  }
  var service = {
    /************* CALCULATE DISTANCE *************/
    //http://blog.dynamicprogrammer.com/2014/05/23/calculate-distance-with-geolocation-and-PhoneGap-part-9.html
    calculateDistance: function(starting, ending){
        var startingLat = parseFloat(starting.latitude);
        var startingLon = parseFloat(starting.longitude);
        var endingLat = parseFloat(ending.latitude);
        var endingLon = parseFloat(ending.longitude);

        var KM_RATIO = 6371;
        try {      
            var dLat = toRad(endingLat - startingLat);
            var dLon = toRad(endingLon - startingLon);
            var lat1Rad = toRad(startingLat);
            var lat2Rad = toRad(endingLat);

            var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
                    Math.sin(dLon / 2) * Math.sin(dLon / 2) * Math.cos(lat1Rad) * Math.cos(lat2Rad);
            var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
            var d = KM_RATIO * c;
            console.log("Distance calulated : " + d.toFixed(3));
            return d.toFixed(3); //KILOMTERS TO MILES 1 - 0.621371
        } catch(e) {
            console.log("Error calculating Distance");
            return -1;
        }
    }
  };

  return service;
})


.factory('MediaSrv', function($q, $ionicPlatform, $window){
  var service = {
    loadMedia: loadMedia,
    getStatusMessage: getStatusMessage,
    getErrorMessage: getErrorMessage
  };
  
  function loadMedia(src, onError, onStatus, onStop){
    var defer = $q.defer();
    $ionicPlatform.ready(function(){

      var mediaSuccess = function(){
        console.log("Media Play Success ");
        if(onStop){
            console.log("OnStop called");
            onStop();
        }
      };
      var mediaError = function(err){
        console.log("Error in Media Play: " + JSON.stringify(err));
        _logError(src, err);
        if(onError){
            console.log("Media error in loadMedia : " + err);
            onError(err);
        }
      };
      var mediaStatus = function(status){
        if(onStatus){
          onStatus(status);
        } 
      };

      if($ionicPlatform.is('android')){
        if (src.indexOf("http") > -1) {
            console.log("We are about to play a file from URL, do not prepend android extension to it");
        }
        else {
            console.log("Platform is Android, updating src [" + src + "] to /android_asset/www/" + src);
            src = '/android_asset/www/' + src;
        }
      }
      defer.resolve(new $window.Media(src, mediaSuccess, mediaError, mediaStatus));
    });
    return defer.promise;
  };
  
  function _logError(src, err){
    console.error('media error', {
      code: err.code,
      message: getErrorMessage(err.code)
    });
  }
  
  function getStatusMessage(status){
    if(status === 0){return 'Media.MEDIA_NONE';}
    else if(status === 1){return 'Media.MEDIA_STARTING';}
    else if(status === 2){return 'Media.MEDIA_RUNNING';}
    else if(status === 3){return 'Media.MEDIA_PAUSED';}
    else if(status === 4){return 'Media.MEDIA_STOPPED';}
    else {return 'Unknown status <'+status+'>';}
  }
  
  function getErrorMessage(code){
    if(code === 1){return 'MediaError.MEDIA_ERR_ABORTED';}
    else if(code === 2){return 'MediaError.MEDIA_ERR_NETWORK';}
    else if(code === 3){return 'MediaError.MEDIA_ERR_DECODE';}
    else if(code === 4){return 'MediaError.MEDIA_ERR_NONE_SUPPORTED';}
    else {return 'Unknown code <'+code+'>';}
  }
   return service;
})

/**
 * A simple example service that returns some data.
 */
.factory('Reports',['$http','PARSE_CREDENTIALS',function($http, PARSE_CREDENTIALS){
    return {
        getByTime:function(lat, lon, callback){
            Parse.initialize('ZmqvFWg6V7u0ny8bX24u7PAnKvfewOvRDxfNdoxH', 'HlzTePUSlhYKCukte0Jkx0BoITzuxezBs7Zvo521');
            var todaysDate = new Date();
            todaysDate.setHours(-5); //returns beginning of the day
            console.log("Finding recordings within 5 hrs, date " + todaysDate);

            if (!lat || !lon) {
              lat = 39.975520599999996;
              lon = -75.1410851;
            }
         
            //Get the current location
            var userGeoPoint = new Parse.GeoPoint(lat, lon);
            console.log(JSON.stringify(userGeoPoint));

            var Recordings = Parse.Object.extend("Recordings");
            var query = new Parse.Query(Recordings);
            query.greaterThanOrEqualTo("createdAt", todaysDate);
            query.withinMiles('geoLocation', userGeoPoint, 10);
            query.find({
              success: function(results) {
                console.log("Successfully retrieved " + results.length + " scores.");
                // Do something with the returned Parse.Object values
                for (var i = 0; i < results.length; i++) { 
                  var object = results[i];
                  //console.log("Entry[" + i + "]" + object.id + ' - ' + object.createdAt);
                }
                
                callback(results);
              },
              error: function(error) {
                var alertPopup = $ionicPopup.alert({
                  title: 'There was an error with the local time!' + error.code,
                  template: 'Please report this to support!'
                });
                alertPopup.then(function(res) {
                    console.log('User clicked continue for local time');
                });
              }
            });
        },
        updateEntryHelpful:function(_objectID){
            // Create a pointer to an object of class Point with id dlkj83d
            var Recording = Parse.Object.extend("Recordings");
            var query = new Parse.Query(Recording);
            console.log("Searching for _objectID = " + _objectID);
            query.equalTo("objectId", _objectID);
            query.first({
              success: function(results) {
                console.log("results = " + JSON.stringify(results));

                //console.log(JSON.stringify(object.attributes));
                var currentRating = results.attributes.helpfulRating;
                console.log("Current rating = " + currentRating );
                
                if (!currentRating) {
                    console.log("Entry hasn't been rated yet, setting to 1");
                    results.set("helpfulRating",  1);
                    results.save();    
                }
                else{
                    var newRating = parseInt(currentRating) + 1;
                    console.log("new rating = " + newRating);
                    results.set("helpfulRating",  newRating);
                    results.save();  
                }
              },
              error: function(error) {
               var alertPopup = $ionicPopup.alert({
                     title: 'There was an error updating entry!' + error.code,
                     template: 'Please report to support!'
                });
                alertPopup.then(function(res) {
                    console.log('User clicked continue for updateEntryHelpful');
                });
              }
            });
        },
        updateEntryNotHelpful:function(_objectID){
            // Create a pointer to an object of class Point
            var Recording = Parse.Object.extend("Recordings");
            var query = new Parse.Query(Recording);
            console.log("Searching for _objectID = " + _objectID);
            query.equalTo("objectId", _objectID);
            query.first({
              success: function(results) {
                console.log("results = " + JSON.stringify(results));
                var currentRating = results.attributes.helpfulRating;
                console.log("Current rating = " + currentRating );
                
                console.log("Setting bannedUserNamesCache = " + results.attributes.username);
                window.localStorage.setItem("bannedUserNamesCache", results.attributes.username);
                
                if (!currentRating) {
                    console.log("Entry hasn't been rated yet, setting to -1");
                    results.set("helpfulRating",  -1);
                    results.save();    
                }
                else{
                    var newRating = parseInt(currentRating) - 1;
                    console.log("new rating = " + newRating);
                    results.set("helpfulRating",  newRating);
                    results.save();  
                }
              },
              error: function(error) {
                var alertPopup = $ionicPopup.alert({
                     title: 'There was an error flagging entry!' + error.code,
                     template: 'Please report to support!'
                });
                alertPopup.then(function(res) {
                    console.log('User clicked continue for updateEntryNotHelpful');
                });
              }
            });
        },
        get:function(id){
            return $http.get('https://api.parse.com/1/classes/Recordings'+id,{
                headers:{
                    'X-Parse-Application-Id': PARSE_CREDENTIALS.APP_ID,
                    'X-Parse-REST-API-Key':PARSE_CREDENTIALS.REST_API_KEY,
                }
            });
        }
    }
}]);